package com.ho.test.reflexion;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import junit.framework.TestCase;

import com.ho.test.reflexion.tocheck.TestClassInstance;

/**
 * @author huseyin
 *
 */
public class JUClassToolsWithTestClassInstance extends TestCase {

	private ReflectionTools classTools = null;

	public JUClassToolsWithTestClassInstance(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
		classTools = new ReflectionTools();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		classTools = null;
	}

	public void test1Class() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test1Class ------------------------------------------");
			System.out.println("---------------------------------------------------------------");
			
			TestClassInstance testClassInstance = new TestClassInstance();
			String name = null;
			Field f = null;
			Field[] ftab = null;
			Method m = null;
			Method[] mtab = null;
			Constructor cons = null;
			Constructor[] constab = null;
			Class[] itab = null;
			Class superclass = null;
			Package pck = null;
			
			// 
			System.out.println("-----------------------------------------");
			name = classTools.getName(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			try{ f = classTools.getField(testClassInstance,"privatefield");}catch(NoSuchFieldException ex){System.out.println("ERROR: getField(privatefield) not accessible!");}
			System.out.println("-----------------------------------------");
			f = classTools.getField(testClassInstance,"publicfield");
			System.out.println("-----------------------------------------");
			f = classTools.getField(testClassInstance,"publicstaticfield");
			System.out.println("-----------------------------------------");
			try{ f = classTools.getField(testClassInstance,"privatestaticfield");}catch(NoSuchFieldException ex){System.out.println("ERROR: getField(privatestaticfield) not accessible!");}
			//
			System.out.println("-----------------------------------------");
			ftab = classTools.getFields(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			m = classTools.getMethod(testClassInstance,"getPublicMethod",new Class[]{String.class});
			System.out.println("-----------------------------------------");
			m = classTools.getMethod(testClassInstance,"getPublicStaticMethod",new Class[]{String.class});
			System.out.println("-----------------------------------------");
			try{ m = classTools.getMethod(testClassInstance,"getPrivateMethod",new Class[]{String.class});}catch(NoSuchMethodException ex){System.out.println("ERROR: getMethod(getPrivateMethod) not accessible!");}
			System.out.println("-----------------------------------------");
			try{ m = classTools.getMethod(testClassInstance,"getPrivateStaticMethod",new Class[]{String.class});}catch(NoSuchMethodException ex){System.out.println("ERROR: getMethod(getPrivateStaticMethod) not accessible!");}
			//
			System.out.println("-----------------------------------------");
			mtab = classTools.getMethods(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			cons = classTools.getConstructor(testClassInstance);
			System.out.println("-----------------------------------------");
			cons = classTools.getConstructor(testClassInstance,new Class[]{String.class});
			System.out.println("-----------------------------------------");
			cons = classTools.getConstructor(testClassInstance,new Class[]{String.class, int.class});
			System.out.println("-----------------------------------------");
			cons = classTools.getConstructor(testClassInstance,new Class[]{String.class, Integer.class});
			System.out.println("-----------------------------------------");
			try{ cons = classTools.getConstructor(testClassInstance,new Class[]{String.class, Integer.class, long.class});}catch(NoSuchMethodException ex){System.out.println("ERROR: getConstructor(PrivateConstructeur) not accessible!");}
			//
			System.out.println("-----------------------------------------");
			constab = classTools.getConstructors(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			itab = classTools.getInterfaces(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			superclass = classTools.getSuperclass(testClassInstance);
			//
			System.out.println("-----------------------------------------");
			pck = classTools.getPackage(testClassInstance);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void test2Field() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test2Field ------------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Field f = null;
			Field[] ftab = null;

			//
			System.out.println("-----------------------------------------");
			ftab = classTools.getFields(testClassInstance);
			for (int i = 0; i < ftab.length; i++) {
				System.out.println("-----------------------------------------");
				f = ftab[i];
				System.out.println("f["+i+"].getName="+f.getName());
				System.out.println("f["+i+"].getType="+f.getType());
				System.out.println("f["+i+"].getModifiers="+f.getModifiers());
				if(Modifier.isPublic(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isStatic");	
			}
			
			//
			System.out.println("-----------------------------------------");
			try{ f = classTools.getField(testClassInstance,"privatefield");}catch(NoSuchFieldException ex){System.out.println("ERROR: getField(privatefield) not accessible!");}
			//
			System.out.println("-----------------------------------------");
			f = classTools.getField(testClassInstance,"publicfield");
			System.out.println("f.getName="+f.getName());
			System.out.println("f.getType="+f.getType());
			System.out.println("f.getModifiers="+f.getModifiers());
			if(Modifier.isPublic(f.getModifiers())) System.out.println("f.getModifiers=isPublic");
			if(Modifier.isPrivate(f.getModifiers())) System.out.println("f.getModifiers=isPrivate");
			if(Modifier.isProtected(f.getModifiers())) System.out.println("f.getModifiers=isProtected");
			if(Modifier.isStatic(f.getModifiers())) System.out.println("f.getModifiers=isStatic");
			//
			System.out.println("-----------------------------------------");
			f = classTools.getField(testClassInstance,"publicstaticfield");
			System.out.println("f.getName="+f.getName());
			System.out.println("f.getType="+f.getType());
			System.out.println("f.getModifiers="+f.getModifiers());
			if(Modifier.isPublic(f.getModifiers())) System.out.println("f.getModifiers=isPublic");
			if(Modifier.isPrivate(f.getModifiers())) System.out.println("f.getModifiers=isPrivate");
			if(Modifier.isProtected(f.getModifiers())) System.out.println("f.getModifiers=isProtected");
			if(Modifier.isStatic(f.getModifiers())) System.out.println("f.getModifiers=isStatic");
			//
			System.out.println("-----------------------------------------");
			try{ f = classTools.getField(testClassInstance,"privatestaticfield");}catch(NoSuchFieldException ex){System.out.println("ERROR: getField(privatestaticfield) not accessible!");}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
	
	public void test3Method() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test3Method -----------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Method m = null;
			Method[] mtab = null;
			Class[] ctab = null;
			
			//
			System.out.println("-----------------------------------------");
			mtab = classTools.getMethods(testClassInstance);
			for (int i = 0; i < mtab.length; i++) {
				System.out.println("-----------------------------------------");
				m = mtab[i];
				System.out.println("m["+i+"].getName="+m.getName());
				System.out.println("m["+i+"].getReturnType="+m.getReturnType());
				//
				ctab = m.getParameterTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("m["+i+"].getParameterTypes="+ctab[j].toString());
				}
				//
				if(Modifier.isPublic(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isStatic");	
				//
				ctab = m.getExceptionTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("m["+i+"].getExceptionTypes="+ctab[j].toString());
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}		

	public void test4Constructor() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test4Constructor ------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Constructor cons = null;
			Constructor[] constab = null;
			Class[] ctab = null;
			
			//
			System.out.println("-----------------------------------------");
			constab = classTools.getConstructors(testClassInstance);
			for (int i = 0; i < constab.length; i++) {
				System.out.println("-----------------------------------------");
				cons = constab[i];
				System.out.println("cons["+i+"].getName="+cons.getName());
				//
				ctab = cons.getParameterTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("cons["+i+"].getParameterTypes="+ctab[j].toString());
				}
				//
				if(Modifier.isPublic(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isStatic");	
				//
				ctab = cons.getExceptionTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("cons["+i+"].getExceptionTypes="+ctab[j].toString());
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void test5ModifyField() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test5ModifyField ------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			//
			obj = classTools.getFieldValue(testClassInstance,"publicfield");
			System.out.println("getFieldValue(publicfield)"+obj!=null?obj.toString():null);
			//
			obj = classTools.getFieldValue(testClassInstance,"publicstaticfield");
			System.out.println("getFieldValue(publicstaticfield)"+obj!=null?obj.toString():null);
			//
			classTools.changeFieldValue(testClassInstance,"publicfield","publicfield_value_NEW");
			classTools.changeFieldValue(testClassInstance,"publicstaticfield","publicstaticfield_value_NEW");
			//
			obj = classTools.getFieldValue(testClassInstance,"publicfield");
			System.out.println("getFieldValue(publicfield)"+obj!=null?obj.toString():null);
			//
			obj = classTools.getFieldValue(testClassInstance,"publicstaticfield");
			System.out.println("getFieldValue(publicstaticfield)"+obj!=null?obj.toString():null);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void test6InvokeMethod() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test6InvokeMethod -----------------------------------");
			System.out.println("---------------------------------------------------------------");
			/*  Exemple du couple Integer/int : pour le premier ce sera Integer.class et pour le second Integer.TYPE. 
			    Ainsi, dans l'exemple suivant :
				Class c = Class.forName("maClasse");
				Class[] p1 = new Class[]{Integer.class, Integer.class};
				Class[] p2 = new Class[]{Integer.TYPE, Integer.TYPE};
				Method m1 = c.getMethod("somme",p1);
				Method m2 = c.getMethod("somme",p2);
				m1 correspond ici � la m�thode somme(Integer, Integer) alors que m2 correspond � somme(int, int).
			*/
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			Object[] objtab= null;
			
			//
			objtab = new Object[]{"paramString"};
			obj = classTools.invokeMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{"paramString"};
			obj = classTools.invokeMethod(testClassInstance,"getPublicStaticMethod",objtab);
			//
			objtab = new Object[]{new Integer(12)};
			obj = classTools.invokeMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{12};
			obj = classTools.invokeMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{new Object()};
			obj = classTools.invokeMethod(testClassInstance,"getPublicMethod",objtab);
			try {
				//
				objtab = new Object[] { new Float(12.12F) }; // OBJECT
				obj = classTools.invokeMethod(testClassInstance,"getPublicMethod", objtab);
			} catch (Exception e) {
				System.out.println("ERROR: invokeMethod(getPublicMethod(Object) with getPublicMethod(Float)) not accessible!");
			}
			try {
				//
				objtab = new Object[] { "paramString" };
				obj = classTools.invokeMethod(testClassInstance,"getPrivateMethod", objtab);
			} catch (Exception e) {
				System.out.println("ERROR: invokeMethod(getPrivateMethod) not accessible!");
			}
			try {
				//
				objtab = new Object[] { "paramString" };
				obj = classTools.invokeMethod(testClassInstance,"getPrivateStaticMethod", objtab);
			} catch (Exception e) {
				System.out.println("ERROR: invokeMethod(getPrivateStaticMethod) not accessible!");
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void test7CreateInstance() {

		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test7CreateInstance ---------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			Object[] objtab= null;
			Constructor cons = null;

			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
			cons = classTools.getConstructor(testClassInstance,new Class[]{String.class,String.class});
			testClassInstance = (TestClassInstance) cons.newInstance("publicfield_value2","publicstaticfield_value2");
			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void test8AllFields() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test8AllFields --------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Field f = null;
			Field[] ftab = null;

			//
			System.out.println("-----------------------------------------");
			ftab = classTools.getDeclaredFields(testClassInstance);
			for (int i = 0; i < ftab.length; i++) {
				System.out.println("-----------------------------------------");
				f = ftab[i];
				System.out.println("f["+i+"].getName="+f.getName());
				System.out.println("f["+i+"].getType="+f.getType());
				System.out.println("f["+i+"].getModifiers="+f.getModifiers());
				if(Modifier.isPublic(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(f.getModifiers())) System.out.println("f["+i+"].getModifiers=isStatic");	
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}	

	public void test9AllMethods() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test9AllMethods -------------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Method m = null;
			Method[] mtab = null;
			Class[] ctab = null;
			
			//
			System.out.println("-----------------------------------------");
			mtab = classTools.getDeclaredMethods(testClassInstance);
			for (int i = 0; i < mtab.length; i++) {
				System.out.println("-----------------------------------------");
				m = mtab[i];
				System.out.println("m["+i+"].getName="+m.getName());
				System.out.println("m["+i+"].getReturnType="+m.getReturnType());
				//
				ctab = m.getParameterTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("m["+i+"].getParameterTypes="+ctab[j].toString());
				}
				//
				if(Modifier.isPublic(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(m.getModifiers())) System.out.println("m["+i+"].getModifiers=isStatic");	
				//
				ctab = m.getExceptionTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("m["+i+"].getExceptionTypes="+ctab[j].toString());
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}		
	
	public void test10AllConstructors() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test10AllConstructors --------------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance();
			Constructor cons = null;
			Constructor[] constab = null;
			Class[] ctab = null;
			
			//
			System.out.println("-----------------------------------------");
			constab = classTools.getDeclaredConstructors(testClassInstance);
			for (int i = 0; i < constab.length; i++) {
				System.out.println("-----------------------------------------");
				cons = constab[i];
				System.out.println("cons["+i+"].getName="+cons.getName());
				//
				ctab = cons.getParameterTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("cons["+i+"].getParameterTypes="+ctab[j].toString());
				}
				//
				if(Modifier.isPublic(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isPublic");
				if(Modifier.isPrivate(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isPrivate");
				if(Modifier.isProtected(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isProtected");
				if(Modifier.isStatic(cons.getModifiers())) System.out.println("cons["+i+"].getModifiers=isStatic");	
				//
				ctab = cons.getExceptionTypes();
				for (int j = 0; j < ctab.length; j++) {
					System.out.println("cons["+i+"].getExceptionTypes="+ctab[j].toString());
				}
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void test11ModifyPrivateOrProtectedField() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test11ModifyPrivateOrProtectedField -----------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			//
			obj = classTools.getDeclaredFieldValue(testClassInstance,"publicfield");
			System.out.println("getDeclaredFieldValue(publicfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"publicstaticfield");
			System.out.println("getDeclaredFieldValue(publicstaticfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"privatefield");
			System.out.println("getDeclaredFieldValue(privatefield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"privatestaticfield");
			System.out.println("getDeclaredFieldValue(privatestaticfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"protectedfield");
			System.out.println("getDeclaredFieldValue(protectedfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"protectedstaticfield");
			System.out.println("getDeclaredFieldValue(protectedstaticfield)"+obj!=null?obj.toString():null);
			//
			classTools.changeDeclaredFieldValue(testClassInstance,"publicfield","publicfield_value_NEW");
			classTools.changeDeclaredFieldValue(testClassInstance,"publicstaticfield","publicstaticfield_value_NEW");
			classTools.changeDeclaredFieldValue(testClassInstance,"privatefield","privatefield_value_NEW");
			classTools.changeDeclaredFieldValue(testClassInstance,"privatestaticfield","privatestaticfield_value_NEW");
			classTools.changeDeclaredFieldValue(testClassInstance,"protectedfield","protectedfield_value_NEW");
			classTools.changeDeclaredFieldValue(testClassInstance,"protectedstaticfield","protectedstaticfield_value_NEW");
			//
			obj = classTools.getDeclaredFieldValue(testClassInstance,"publicfield");
			System.out.println("getDeclaredFieldValue(publicfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"publicstaticfield");
			System.out.println("getDeclaredFieldValue(publicstaticfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"privatefield");
			System.out.println("getDeclaredFieldValue(privatefield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"privatestaticfield");
			System.out.println("getDeclaredFieldValue(privatestaticfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"protectedfield");
			System.out.println("getDeclaredFieldValue(protectedfield)"+obj!=null?obj.toString():null);
			obj = classTools.getDeclaredFieldValue(testClassInstance,"protectedstaticfield");
			System.out.println("getDeclaredFieldValue(protectedstaticfield)"+obj!=null?obj.toString():null);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void test12InvokeDeclaredMethod() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test12InvokeDeclaredMethod --------------------------");
			System.out.println("---------------------------------------------------------------");
//			  Exemple du couple Integer/int : pour le premier ce sera Integer.class et pour le second Integer.TYPE. 
//			    Ainsi, dans l'exemple suivant :
//				Class c = Class.forName("maClasse");
//				Class[] p1 = new Class[]{Integer.class, Integer.class};
//				Class[] p2 = new Class[]{Integer.TYPE, Integer.TYPE};
//				Method m1 = c.getMethod("somme",p1);
//				Method m2 = c.getMethod("somme",p2);
//				m1 correspond ici � la m�thode somme(Integer, Integer) alors que m2 correspond � somme(int, int).
			
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			Object[] objtab= null;
			
			//
			objtab = new Object[]{"paramString"};
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{"paramString"};
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPublicStaticMethod",objtab);
			//
			objtab = new Object[]{new Integer(12)};
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{12};
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[]{new Object()};
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPublicMethod",objtab);
			//
			objtab = new Object[] { "paramString" };
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPrivateMethod", objtab);
			//
			objtab = new Object[] { "paramString" };
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getPrivateStaticMethod", objtab);
			//
			objtab = new Object[] { "paramString" };
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getProtectedMethod", objtab);
			//
			objtab = new Object[] { "paramString" };
			obj = classTools.invokeDeclaredMethod(testClassInstance,"getProtectedStaticMethod", objtab);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void test13CreateInstanceDeclared() {
		try {
			System.out.println("---------------------------------------------------------------");
			System.out.println("--------- test13CreateInstanceDeclared ------------------------");
			System.out.println("---------------------------------------------------------------");
			TestClassInstance testClassInstance = new TestClassInstance("publicfield_value","publicstaticfield_value");
			Object obj = null;
			Object[] objtab= null;
			Constructor cons = null;
			//
			// public TestClassInstance(String str1, String str2){
			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
			cons = classTools.getDeclaredConstructor(testClassInstance,new Class[]{String.class,String.class});
			testClassInstance = (TestClassInstance) cons.newInstance("publicfield_value2","publicstaticfield_value2");
			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
			//
			// private TestClassInstance(String str1, String str2, long lg){
			System.out.println("testClassInstance:  getPrivatefield()="+testClassInstance.getPrivatefield() + " - getPrivatestaticfield()=" + testClassInstance.getPrivatestaticfield());
			cons = classTools.getDeclaredConstructor(testClassInstance,new Class[]{String.class,String.class,Long.TYPE});
			testClassInstance = (TestClassInstance) cons.newInstance("privatefield_value2","privatestaticfield_value2",0);
			System.out.println("testClassInstance:  getPrivatefield()="+testClassInstance.getPrivatefield() + " - getPrivatestaticfield()=" + testClassInstance.getPrivatestaticfield());
			//
			// protected TestClassInstance(String str1, String str2, long lg, String str3){
			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
			cons = classTools.getDeclaredConstructor(testClassInstance,new Class[]{String.class,String.class,Long.TYPE,String.class});
			testClassInstance = (TestClassInstance) cons.newInstance("publicfield_value2","publicstaticfield_value2",0,"str3");
			System.out.println("testClassInstance:  getPublicfield()="+testClassInstance.getPublicfield() + " - getPublicstaticfield()=" + testClassInstance.getPublicstaticfield());
			
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
}
